// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: account_transfers.sql

package db

import (
	"context"
)

const createAccount_transfer = `-- name: CreateAccount_transfer :one
INSERT INTO account_transfers (
    from_account_id,
    amount,
    to_account_id
) VALUES (
    $1, $2, $3
) RETURNING id, from_account_id, to_account_id, amount, created_at
`

type CreateAccount_transferParams struct {
	FromAccountID int64 `json:"from_account_id"`
	Amount        int64 `json:"amount"`
	ToAccountID   int64 `json:"to_account_id"`
}

func (q *Queries) CreateAccount_transfer(ctx context.Context, arg CreateAccount_transferParams) (AccountTransfers, error) {
	row := q.db.QueryRowContext(ctx, createAccount_transfer, arg.FromAccountID, arg.Amount, arg.ToAccountID)
	var i AccountTransfers
	err := row.Scan(
		&i.ID,
		&i.FromAccountID,
		&i.ToAccountID,
		&i.Amount,
		&i.CreatedAt,
	)
	return i, err
}

const getAccount_transfer = `-- name: GetAccount_transfer :one
SELECT id, from_account_id, to_account_id, amount, created_at FROM account_transfers
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetAccount_transfer(ctx context.Context, id int64) (AccountTransfers, error) {
	row := q.db.QueryRowContext(ctx, getAccount_transfer, id)
	var i AccountTransfers
	err := row.Scan(
		&i.ID,
		&i.FromAccountID,
		&i.ToAccountID,
		&i.Amount,
		&i.CreatedAt,
	)
	return i, err
}

const listAccount_transfers = `-- name: ListAccount_transfers :many
SELECT id, from_account_id, to_account_id, amount, created_at FROM account_transfers
WHERE
    from_account_id = $1 OR to_account_id = $2
ORDER BY id
LIMIT $3
OFFSET $4
`

type ListAccount_transfersParams struct {
	FromAccountID int64 `json:"from_account_id"`
	ToAccountID   int64 `json:"to_account_id"`
	Limit         int64 `json:"limit"`
	Offset        int64 `json:"offset"`
}

func (q *Queries) ListAccount_transfers(ctx context.Context, arg ListAccount_transfersParams) ([]AccountTransfers, error) {
	rows, err := q.db.QueryContext(ctx, listAccount_transfers,
		arg.FromAccountID,
		arg.ToAccountID,
		arg.Limit,
		arg.Offset,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []AccountTransfers
	for rows.Next() {
		var i AccountTransfers
		if err := rows.Scan(
			&i.ID,
			&i.FromAccountID,
			&i.ToAccountID,
			&i.Amount,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
